% Testowanie 16-kolumnowego histogramu widmowego, tworzonego z 256. prbek sygnau
% Plik wykonywalny w programie Matlab
% Rafa Baranowski (C) 2004

clf; clc; clear;

N=256;
n=0:N-1;

fp=10000;
Tp=1/fp;

t=n*Tp;
f=(n/N)*fp;

fx=39.0625

f1=10*fx+0.5*fx;
A1=1;

f2=45*fx+0.5*fx;
A2=1.5;

f3=30*fx+0.5*fx;
A3=1;

s1=A1*sin(2*pi*f1*t);
s2=A2*sin(2*pi*f2*t);
s3=A3*sin(2*pi*f3*t);

s=s1+s2+s3; 

S=abs(fft(s)/length(s))*2;
Sp=angle(fft(s)/length(s));

subplot(221);
plot(t,s); title('Postac czasowa');

subplot(222);
stem(f(1:N/2),S(1:N/2)); title('Widmo amplitudowe');

subplot(223);
stem(f(1:N/2),unwrap(Sp(1:N/2))/pi); title('Widmo fazowe');

pause; clg;
subplot(211);
stem(f(1:N/2),S(1:N/2)); title('Widmo amplitudowe');

for i=1:16
  hist(i)=sum(S(i*8:(i*8+8)).^2)
end

subplot(212);
stem(1:16,hist); title('Histogram');


