; Przykadowe operacje arytmetyczne
; Rafa Baranowski (C) 2004

.INCLUDE "m16def.inc"

; dodawanie (ustawiany znacznik H)
	ldi	R16, 15
	ldi	R17, 35
	add	R16, R17	; R16 = R16+R17

; dodawanie (ustawiane znaczniki S i N)
	ldi	R16, 10
	ldi	R17, 200
	add	R16, R17	; R16 = R16+R17

; dodawanie z przepenieniem (ustawiany znacznik C)
	ldi	R16, 200
	ldi	R17, 60
	add	R16, R17	; R16 = R16+R17

; przykad ptli iteracyjnej
	ldi	R16, 10
Petla_x10:
				; instrukcje znajdujce si tutaj zostan wykonane
	nop			;   10-krotnie (ich liczba jest ograniczona zakresem
	nop			;   skoku warunkowego, ktry umoliwia cofanie licznika
				;   programu maksymalnie o 63)
	dec	R16
	brne	Petla_x10

; dodawanie liczb ze znakiem
	ldi	R16, 10
	ldi	R17, -20	; R16 = R16+R17
	add	R16, R17

; dodawanie liczb ze znakiem, przepenienie U2
	ldi	R16, -10
	ldi	R17, -120
	add	R16, R17	; R16 = R16+R17

; dodawanie liczby bezporedniej
	ldi	R16, 5
	subi	R16, -10	; R16 = R16+10 (uwaga: C=1!)

; mnoenie liczb cakowytych ze znakiem
	ldi	R16, 200
	ldi	R17, -10
	mulsu	R17, R16

; mnoenie liczb cakowitych (ze znakiem lub bez) przez 2
	ldi	R16, 10
	lsl	R16		; przesuwanie logiczne o jedn pozycj w lewo

; dzielenie liczb cakowitych bez znaku przez 2
	ldi	R16, 9
	lsr	R16		; przesuwanie logiczne o jedn pozycj w prawo

; dzielenie liczb cakowitych ze znakiem przez 2
	ldi	R16, -2
	asr	R16		; przesuwanie arytmetyczne o jedn pozycj w prawo

; przykadowe operacje na liczbach 16-bitowych
	movw	R25:R24, R1:R0
	adiw	R25:R24, 10
	movw	R1:R0, R25:R24

; mnoenie liczb uamkowych ze znakiem
	ldi	R16, q7(-0.125)
	ldi	R17, q7(0.5)
	fmuls	R16, R17

; mnoenie liczby cakowitej przez liczb uamkow
	ldi	R16, 100
	ldi	R17, q7(0.25)
	fmul	R16, R17

; mnoenie uamkowe liczby cakowitej ze znakiem z liczb bez znaku
	ldi	R16, -100
	ldi	R17, (1<<7)+q7(0.11)
	fmulsu	R16, R17

; przykad maskowania rejestru
	ldi	R17, 0x0F
	and	R16, R17

; przykad znajdywania rnic pomidzy wartociami
	ldi	R16, 0b10110101
	ldi	R17, 0b11011100
	eor	R16, R17

Petla:
	rjmp Petla		; ptla nieskoczona
