;************************************************************
;		MILISEKUNDOWA PROCEDURA OPӏNIAJCA
;
; 						Rafa Baranowski (C) 2004
;
; Parametry:
;	R16 - warto opnienia w ms (dla zera - 256 ms)
;	R17 - mnonik opnienia (dla zera - 256x)
;
; Wymagane stae:
;	SYS_FREQ - czstotliwo pracy w MHz
;
Czekaj_ms:
	push	R18
	push	R19
	push	R20
	push	R21

	mov	R20, R16
	mov	R21, R17
	ldi	R18, SYS_FREQ

Czekaj_ms_0:
	mov	R17, R21		;______________
					;              \
Czekaj_ms_1:			;               |
	mov	R16, R20		;__________     |
					;          \    |
Czekaj_ms_2:			;           |   |
	ldi	R19, 249		;______     |   |
					;      \    |   |
	nop				;       |   |   |
Czekaj_ms_3:			;__     |   |   |
	nop				;  \    p   p   p
	dec	R19			;  p3   2   1   0
	brne	Czekaj_ms_3		;__/    |   |   |
					;       |   |   |
	dec	R16			;       |   |   |
	brne	Czekaj_ms_2		;______/    |   |
					;           |   |
	dec	R17			;           |   |
	brne	Czekaj_ms_1		;__________/    |
					;               |
	dec	R18			;               |
	brne	Czekaj_ms_0		;______________/

	pop	R21
	pop	R20
	pop	R19
	pop	R18
	ret
