% Generacja dyskretnych wartoci funkcji sinus dla AVR ASM 2.0
% Plik wykonywalny w programie Matlab
% Rafa Baranowski (C) 2004

clc;

N=256;
n=0:(N-1+64);

out=sin(2*pi*n/N)*127/128;

for i=1:4:length(out)
    disp(['.DB q7(' num2str(out(i),'%6.5f') '), q7(' num2str(out(i+1),'%6.5f') '), q7(' num2str(out(i+2),'%6.5f') '), q7(' num2str(out(i+3),'%6.5f') ')']);
end

plot(n,out)
